"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const graphqlFields = require("graphql-fields");
const setFields = (data) => {
    const fields = [];
    for (const key in data) {
        const isObject = typeof data[key] === 'object';
        const isNotEmpty = isObject && Object.keys(data[key]).length > 0;
        if (isNotEmpty) {
            fields[key] = setFields(data[key]);
        }
        else {
            fields.push(key);
        }
    }
    return fields;
};
/**
 *
 * @param info
 * @returns ['field.subfield', 'field']
 */
const filterGraphqlFields = (info) => {
    const graphqlData = graphqlFields(info);
    const fields = setFields(graphqlData);
    Object.keys(fields).forEach(field => {
        if (Array.isArray(fields[field])) {
            const list = fields[field];
            list.forEach((key) => {
                fields.push(`${field}.${key}`);
            });
            delete fields[field];
        }
    });
    return fields;
};
exports.default = filterGraphqlFields;
//# sourceMappingURL=index.js.map